// Calculator.h : Declaration of the CCalculator

#pragma once
#include "resource.h"       // main symbols


// ICalculator
[
	object,
	uuid("4768571A-352F-40C2-97EB-5592EABE71ED"),
	dual,	helpstring("ICalculator Interface"),
	pointer_default(unique)
]
__interface ICalculator : IDispatch
{
};



// CCalculator

[
	coclass,
	threading("apartment"),
	vi_progid("tvC7Sample1.Calculator"),
	progid("tvC7Sample1.Calculator.1"),
	version(1.0),
	uuid("2FE6F63B-9E21-4554-BB96-247ACBF2F085"),
	helpstring("Calculator Class")
]
class ATL_NO_VTABLE CCalculator : 
	public ICalculator,
	public IDispatchImpl<_ITVCallHandler, &__uuidof(_ITVCallHandler), &LIBID_TERAVoiceLib, /* wMajor = */ 6, /* wMinor = */ 1>
{
public:
	CCalculator()
	{
	}


	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}

	void FinalRelease() 
	{
	}

public:


	// _ITVCallHandler Methods
public:
	STDMETHOD(Init)(_CallController * * objCallController)
	{
		return E_NOTIMPL;
	}
	STDMETHOD(UnInit)()
	{
		return E_NOTIMPL;
	}
	STDMETHOD(DigitReceived)(BSTR * Digit)
	{
		return m_DigitReceived(Digit);
	}
	STDMETHOD(TimePulse)()
	{
		return E_NOTIMPL;
	}
	STDMETHOD(FileSaved)(BSTR * FileName, long * Length)
	{
		return E_NOTIMPL;
	}
	STDMETHOD(PlayDone)()
	{
		return E_NOTIMPL;
	}
private:
	long m_DigitReceived(BSTR * Digit);
};

